var mobxStateTree = require('mobx-state-tree');
var react = require('react');

// export type Snapshot<T extends ModelPropertiesDeclaration> = SnapshotOut<InstanceType<T>>;
var useMstImmer = function useMstImmer(props, initialState) {
  var _useState = react.useState(function () {
      var m = mobxStateTree.types.model(props).actions(function (self) {
        return {
          set: function set(updater) {
            updater(self);
            setSnapshot(mobxStateTree.getSnapshot(mobxStateTree.cast(self)));
          }
        };
      });
      return m.create(typeof initialState === 'function' ? initialState() : initialState);
    }),
    model = _useState[0];
  var _useState2 = react.useState(function () {
      return mobxStateTree.getSnapshot(mobxStateTree.cast(model));
    }),
    snapshot = _useState2[0],
    setSnapshot = _useState2[1];
  return [snapshot, model.set];
};

exports.useMstImmer = useMstImmer;
//# sourceMappingURL=use-mst-immer.js.map
