import { types, getSnapshot, cast } from 'mobx-state-tree';
import { useState } from 'react';

// export type Snapshot<T extends ModelPropertiesDeclaration> = SnapshotOut<InstanceType<T>>;
const useMstImmer = (props, initialState) => {
  const [model] = useState(() => {
    const m = types.model(props).actions(self => ({
      set(updater) {
        updater(self);
        setSnapshot(getSnapshot(cast(self)));
      }
    }));
    return m.create(typeof initialState === 'function' ? initialState() : initialState);
  });
  const [snapshot, setSnapshot] = useState(() => getSnapshot(cast(model)));
  return [snapshot, model.set];
};

export { useMstImmer };
//# sourceMappingURL=use-mst-immer.modern.js.map
