import { types, getSnapshot, cast } from 'mobx-state-tree';
import { useState } from 'react';

// export type Snapshot<T extends ModelPropertiesDeclaration> = SnapshotOut<InstanceType<T>>;
var useMstImmer = function useMstImmer(props, initialState) {
  var _useState = useState(function () {
      var m = types.model(props).actions(function (self) {
        return {
          set: function set(updater) {
            updater(self);
            setSnapshot(getSnapshot(cast(self)));
          }
        };
      });
      return m.create(typeof initialState === 'function' ? initialState() : initialState);
    }),
    model = _useState[0];
  var _useState2 = useState(function () {
      return getSnapshot(cast(model));
    }),
    snapshot = _useState2[0],
    setSnapshot = _useState2[1];
  return [snapshot, model.set];
};

export { useMstImmer };
//# sourceMappingURL=use-mst-immer.module.js.map
